﻿Public Class Form2

    'Dim Freq(4, 450) As Long
    Dim Freq As Long
    Dim CountFlg As Long
    Dim FreqData0 As String
    'Dim FreqData(4, 450) As Double
    Dim FreqData As Double
    Dim DataNo As Short
    Dim MaxdB As Long
    Dim MindB As Long
    Dim MaxFreq As Long
    Dim MinFreq As Long

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        CountFlg = 0
        DataNo = 0
        RadioButton1.Checked = True

        MindB = -50
        MaxdB = 20
        MinFreq = 10
        MaxFreq = 1000000

        RadioButton5.Checked = True
        RadioButton9.Checked = True
        RadioButton16.Checked = True
        RadioButton13.Checked = True

        Chart1.ChartAreas(0).AxisX.Title = "FREQUENCY"
        Chart1.ChartAreas(0).AxisY.Title = "dB"

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Try
            SerialPort1.PortName = TextBox1.Text
            SerialPort1.BaudRate = 9600
            SerialPort1.DataBits = 8
            SerialPort1.Parity = IO.Ports.Parity.None
            SerialPort1.StopBits = IO.Ports.StopBits.One
            SerialPort1.ReceivedBytesThreshold = 12
            SerialPort1.NewLine = vbCrLf
            Call SerialPort1.Open()

            If SerialPort1.IsOpen = True Then
                Button1.BackColor = Color.GreenYellow
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        If SerialPort1.IsOpen = True Then
            Call SerialPort1.Close()
            Button1.BackColor = Color.WhiteSmoke
        End If
        CountFlg = 0
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim strDataReceived As String
        Dim add As New AddDatadelegate(AddressOf AddData)
        Try
            strDataReceived = SerialPort1.ReadLine

        Catch ex As Exception
            strDataReceived = ex.Message
        End Try
        RxDataDisp.Invoke(add, strDataReceived)
    End Sub

    Delegate Sub AddDatadelegate(ByVal str As String)

    Private Sub AddData(ByVal str As String)

        If (CountFlg = 0) Then
            Chart1.ChartAreas(0).AxisX.IsLogarithmic = True
            Chart1.ChartAreas(0).AxisX.MinorGrid.Enabled = True
            Chart1.ChartAreas(0).AxisX.MinorGrid.Interval = 1

            Chart1.ChartAreas(0).AxisX.Minimum = MinFreq
            Chart1.ChartAreas(0).AxisX.Maximum = MaxFreq
            Chart1.ChartAreas(0).AxisY.Minimum = MindB
            Chart1.ChartAreas(0).AxisY.Maximum = MaxdB
        End If

        RxDataDisp.Text = str

        Freq = Long.Parse(str.Substring(0, str.IndexOf(",")))
        FreqData0 = str.Substring(str.IndexOf(",") + 1)
        FreqData = Long.Parse(FreqData0.Substring(0))
        FreqData = FreqData * 3.3 / 1024 * 95 / 2.5 - 68

        Chart1.Series(DataNo).Points.AddXY(Freq, FreqData)

        CountFlg = 1


    End Sub

    Private Sub RadioButton1_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton1.CheckedChanged
        DataNo = 0
        CountFlg = 0
    End Sub

    Private Sub RadioButton2_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton2.CheckedChanged
        DataNo = 1
        CountFlg = 0
    End Sub

    Private Sub RadioButton3_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton3.CheckedChanged
        DataNo = 2
        CountFlg = 0
    End Sub

    Private Sub RadioButton4_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton4.CheckedChanged
        DataNo = 3
        CountFlg = 0
    End Sub

    Private Sub RadioButton5_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton5.CheckedChanged
        MaxdB = 20
        Chart1.ChartAreas(0).AxisY.Maximum = MaxdB
    End Sub

    Private Sub RadioButton6_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton6.CheckedChanged
        MaxdB = 10
        Chart1.ChartAreas(0).AxisY.Maximum = MaxdB
    End Sub

    Private Sub RadioButton7_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton7.CheckedChanged
        MaxdB = 0
        Chart1.ChartAreas(0).AxisY.Maximum = MaxdB
    End Sub

    Private Sub RadioButton8_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton8.CheckedChanged
        MaxdB = -10
        Chart1.ChartAreas(0).AxisY.Maximum = MaxdB
    End Sub

    Private Sub RadioButton12_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton12.CheckedChanged
        MindB = -20
        Chart1.ChartAreas(0).AxisY.Minimum = MindB
    End Sub

    Private Sub RadioButton11_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton11.CheckedChanged
        MindB = -30
        Chart1.ChartAreas(0).AxisY.Minimum = MindB
    End Sub

    Private Sub RadioButton10_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton10.CheckedChanged
        MindB = -40
        Chart1.ChartAreas(0).AxisY.Minimum = MindB
    End Sub

    Private Sub RadioButton9_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton9.CheckedChanged
        MindB = -50
        Chart1.ChartAreas(0).AxisY.Minimum = MindB
    End Sub

    Private Sub RadioButton16_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton16.CheckedChanged
        MaxFreq = 1000000
        Chart1.ChartAreas(0).AxisX.Maximum = MaxFreq
    End Sub

    Private Sub RadioButton15_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton15.CheckedChanged
        MaxFreq = 100000
        Chart1.ChartAreas(0).AxisX.Maximum = MaxFreq
    End Sub

    Private Sub RadioButton14_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton14.CheckedChanged
        MaxFreq = 10000
        Chart1.ChartAreas(0).AxisX.Maximum = MaxFreq
    End Sub

    Private Sub RadioButton18_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton18.CheckedChanged
        MinFreq = 1000
        Chart1.ChartAreas(0).AxisX.Minimum = MinFreq
    End Sub

    Private Sub RadioButton17_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton17.CheckedChanged
        MinFreq = 100
        Chart1.ChartAreas(0).AxisX.Minimum = MinFreq
    End Sub

    Private Sub RadioButton13_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton13.CheckedChanged
        MinFreq = 10
        Chart1.ChartAreas(0).AxisX.Minimum = MinFreq
    End Sub

    Private Sub RadioButton19_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton19.CheckedChanged
        MaxFreq = 1000
        Chart1.ChartAreas(0).AxisX.Maximum = MaxFreq
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Chart1.Series(0).Points.Clear()
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Chart1.Series(1).Points.Clear()
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Chart1.Series(2).Points.Clear()
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Chart1.Series(3).Points.Clear()
    End Sub
End Class